#include "stdafx.h"
#include "P4BridgeClient.h"
#include "P4BridgeServer.h"
#include "P4Connection.h"

#ifdef _DEBUG_MEMORY
P4Connection::P4Connection(ConnectionManager* conMgr, P4BridgeServer* pServer, int cmdId)
	: DoublyLinkedListItem((DoublyLinkedList *)conMgr, cmdId), p4base(tP4Connection)
#else
P4Connection::P4Connection(ConnectionManager* conMgr, P4BridgeServer* pServer, int cmdId)
	: DoublyLinkedListItem((DoublyLinkedList *)conMgr, cmdId)
#endif
{
		clientNeedsInit = 1;
		ui = NULL;
		isAlive = 1;
}

P4Connection::~P4Connection(void)
{
	if (clientNeedsInit == 0)
	{
		Error e;
		this->Final( &e );
		clientNeedsInit = 1;
	}
	if (ui)
	{
		delete ui;
	}
}

void P4Connection::cancel_command() 
{
	isAlive = 0;
}

// KeepAlive functionality
int	P4Connection::IsAlive()
{
	return isAlive;
}

void P4Connection::Disconnect( void )
{
	if (clientNeedsInit == 0)
	{
		Error e;
		this->Final( &e );

		clientNeedsInit = 1;
	}
}

void P4Connection::SetCharset( CharSetApi::CharSet c, CharSetApi::CharSet filec )
{	
	ClientApi::SetCharset(CharSetApi::Name(c));
	SetTrans( CharSetApi::NOCONV, c, filec, CharSetApi::NOCONV );
}

const StrPtr & P4Connection::GetConfig() { return P4BridgeServer::enviro.GetConfig(); }

const StrArray* P4Connection::GetConfigs() { return P4BridgeServer::enviro.GetConfigs(); }

StrBuf clientName;

const StrPtr & P4Connection::GetClient()
{
	char *p4client = P4BridgeServer::enviro.Get("P4CLIENT");
	clientName.Set(p4client ? p4client : "");
	
	return clientName;
}

static Error err;

void P4Connection::SetClient(const char *c)
{
	ClientApi::SetClient(c);
}

void P4Connection::SetClient( const StrPtr *c )
{
	const char *val = c->Value();
	SetClient(val);
}




